var sourceConrolProviders = require('./source-control-providers.js');
var globalErrorHandler = require('./global-error-handler');
require('./polyfills.js');

var CIA = require('./cli.js').CIA,
    cia = new CIA(sourceConrolProviders);

process.on('uncaughtException', function (err) {
    globalErrorHandler.setLastError(err);
    process.exit(1);
});

cia.run(function (exitCode) {
    if (exitCode === undefined || exitCode===0)
        console.log("Build agent done");
    else
        console.log("Build agent exited with code "+exitCode);
    if(globalErrorHandler.hasErrors()){
        globalErrorHandler.printLastError();
    }
    process.exit(exitCode);
});