var formatMap = {
    commit: '"%H"',
    authorName: '"%an"',
    authorEmail: '"%ae"',
    committerName: '"%cn"',
    committerEmail: '"%ce"',
    authorDate: '"%at000"',
    committerDate: '"%ct000"',
    title: '"%f"'
};

var formatBuilder = function () {
    var params = [];
    return {
        withCommit: function (alias) {
            alias = alias || 'commit';
            params.push('"' + alias + '":' + formatMap.commit);
            return this;
        },
        withAuthorName: function (alias) {
            alias = alias || 'authorName';
            params.push('"' + alias + '":' + formatMap.authorName);
            return this;
        },
        withAuthorEmail: function (alias) {
            alias = alias || 'authorEmail';
            params.push('"' + alias + '":' + formatMap.authorEmail);
            return this;
        },
        withAuthorDate: function (alias) {
            alias = alias || 'authorDate';
            params.push('"' + alias + '":' + formatMap.authorDate);
            return this;
        },
        withCommitTerEmail: function (alias) {
            alias = alias || 'committerEmail';
            params.push('"' + alias + '":' + formatMap.committerEmail);
            return this;
        },
        withCommitterName: function (alias) {
            alias = alias || 'committerName';
            params.push('"' + alias + '":' + formatMap.committerName);
            return this;
        },
        withCommitterDate: function (alias) {
            alias = alias || 'committerDate';
            params.push('"' + alias + '":' + formatMap.committerDate);
            return this;
        },
        withTitle: function (alias) {
            alias = alias || 'title';
            params.push('"' + alias + '":' + formatMap.title);
            return this;
        },
        build: function () {
            if (params.length < 1) {
                return '';
            }
            if (this.isWindows()) {
                return '{' + params.toString().replace(/"/g, '"""') + '}';
            }
            return '\'{' + params.toString() + '}\'';
        },
        isWindows: function () {
            return /^win/.test(process.platform);
        }
    }
};
module.exports = formatBuilder;