﻿var Promise = require('promise'),
    util = require('util');

function None(cfg) {
    this.getCfg = function getCfg() {
        return cfg;
    }
}

None.prototype.detectCommitVersion = function detectCommitVersion(handlerParams) {
    var cfg = this.getCfg();
    var p = new Promise(function (resolve, reject) {
        var commit = "N/A";
        resolve(commit);
    });
    return p;
}

None.prototype.getBranchHistory = function getBranchHistory(handlerParams) {
    var cfg = this.getCfg();
    var p = new Promise(function (resolve, reject) {
        resolve({
            commitHistory: [],
            commitLog: [],
            commitToIndexMap: {}
        });
    });
    return p;
}

None.prototype.getContributors = function getContributors(handlerParams) {
    var cfg = this.getCfg();
    var p = new Promise(function (resolve, reject) {
        resolve({
            contributors: [],
            emailToIndexMap: {}
        });
    });
    return p;
}

None.prototype.getCommitsPerFile = function getCommitsPerFile(handlerParams) {
    var cfg = this.getCfg();
    var p = new Promise(function (resolve, reject) {
        resolve({
            fileToCommitMap:{}
        });
    });
    return p;
}

None.prototype.getRepositoryUrl = function getRepositoryUrl() {
    return Promise.resolve('');
}

None.prototype.getRootDirectory = function getRootDirectory() {
    return new Promise(function (resolve, reject) {
        resolve('');
    });

}

None.prototype.getFiles = function getGitFiles() {
    return new Promise(function (resolve, reject) {
        resolve(null);
    });

}

module.exports = None;
